set termout on
set echo on
set feedback on
drop index no_more_than_1_mgr_per_dept
/
drop index no_more_than_1_clerk_per_dept
/
update emp
set    job = 'CLERK'
where job = 'NOCLERK'
/
clear screen

select deptno
,      job
,      count(empno)
from   emp
group
by     deptno
,      job
/
prompt Try to implement the constraint. Will not succeed because of Dept 20 with twee Clerks:

pause

create UNIQUE index no_more_than_1_clerk_per_dept
on emp (case job when 'CLERK' then deptno end)
/

prompt Promote one of the Clerks in 20
pause

update emp
set    job = 'NOCLERK'
where  empno = ( select max(empno)
                 from   emp
                 where  deptno=20
                 and    job = 'CLERK'
                )
/
     
prompt Try again to implement this data oriented business rule
pause

create UNIQUE index no_more_than_1_clerk_per_dept
on emp (case job when 'CLERK' then deptno end)
/

prompt Try to promote former CLERK (now NOCLERK) back to his old position
pause


update emp
set    job = 'CLERK'
where job = 'NOCLERK'
/

Prompt Comparable Rule:
pause
clear screen

prompt We cannot have more than one manager per Department

create UNIQUE index no_more_than_1_mgr_per_dept
on emp (case job when 'MANAGER' then deptno end)
/
update emp 
set    job = 'MANAGER'

pause

/

pause

drop index no_more_than_1_mgr_per_dept
/
drop index no_more_than_1_clerk_per_dept
/
update emp
set    job = 'CLERK'
where job = 'NOCLERK'
/
commit
/
clear screen