drop table bigemp
/

create table bigemp
as
( select empno *1000 empno
  ,      ename
  from   emp
)
/

insert into bigemp
value
select empno*10
,      '1'||ename
from   emp  
/
insert into bigemp
value
select empno*50
,      '2'||ename
from   emp  
/
insert into bigemp
value
select empno*100
,      '3'||ename
from   emp  
/
clear screen

rem I created a new table bigemp 

select count(*) 
from   bigemp
/

rem try out the query A
select *
from   bigemp
where  dbms_random.value < 0.1
/
/
/
/
rem A will return either All rows or no rows at all

pause
clear screen
prompt What about Query B

select *
from   ( select *
         from   bigemp
         order
         by     dbms_random.value
       )
where  rownum < 0.1 * (select count(*) from bigemp)       

pause 

/
/
/
/

rem B is returning a random set of exactly 10% of the records 
pause
clear screen
prompt Will c do the trick?

select *
from   bigemp
where  rownum < 10 * dbms_random.value / (select count(*) from bigemp)

pause
/
/
/
/
rem C never returns any rows as ROWNUM can never be smaller than one

pause
clear screen

rem By far the easiest way of doing this is Query D:

select * 
from   bigemp sample (10)

pause

/
/
/
/
pause