set termout on
set echo on
set feedback on
clear screen

select deptno
,      avg(hiredate) avg_hire_date
from   emp
group
by     deptno
/
pause

set termout on
set echo on
set feedback on

drop type DateAvgImpl 
/
drop function avg_date
/

clear screen

create type DateAvgImpl as object
(
  count NUMBER, -- the number of dates processed so far 
  sumdates NUMBER, -- the sum of all dates; that is: the sum of all (date-sysdate) values
  static function ODCIAggregateInitialize(sctx IN OUT DateAvgImpl) 
    return number,
  member function ODCIAggregateIterate(self IN OUT DateAvgImpl, 
    value IN date) return number,
  member function ODCIAggregateTerminate(self IN DateAvgImpl, 
    returnValue OUT date, flags IN number) return number,
  member function ODCIAggregateMerge(self IN OUT DateAvgImpl, 
    ctx2 IN DateAvgImpl) return number
);
/

create or replace type body DateAvgImpl is 
static function ODCIAggregateInitialize(sctx IN OUT DateAvgImpl) 
return number is 
begin
  sctx := DateAvgImpl(0, 0);
  return ODCIConst.Success;
end;

member function ODCIAggregateIterate(self IN OUT DateAvgImpl, value IN date) return number is
begin
  self.count:= self.count+1;
  self.sumdates := self.sumdates + (value - sysdate);
  return ODCIConst.Success;
end;

member function ODCIAggregateTerminate(self IN DateAvgImpl, returnValue OUT date, flags IN number) return number is
begin
  returnValue := self.sumdates/self.count + sysdate;
  return ODCIConst.Success;
end;

member function ODCIAggregateMerge(self IN OUT DateAvgImpl, ctx2 IN DateAvgImpl) return number is
begin
  return ODCIConst.Success;
end;
end;
/
set termout on
set echo on
set output on
set feedback on

clear screen

CREATE or replace FUNCTION Avg_Date (input Date) RETURN Date
PARALLEL_ENABLE AGGREGATE USING DateAvgImpl;
/

select deptno
,      Avg_Date(hiredate) avg_hire_date
from   emp
group
by     deptno

pause

/
pause 

select deptno
,      sysdate - sum(sysdate-hiredate)/count(hiredate) average_date
from   emp
group
by     deptno

pause
/
pause
drop type DateAvgImpl 
/
drop function avg_date
/